import {
    observable,
    action
} from 'mobx';
import * as mobx from 'mobx';
import * as Api from '../apis/staffscheme'; // 引入API接口文件
import {
    WeaForm
} from 'comsMobx';
import {
    WeaTableNew
} from 'comsMobx';
import {
    Modal,
    message,
} from 'antd'
import {
    i18n
} from '../public/i18n';
import {
	findIndex
} from 'lodash';

const toJS = mobx.toJS;
const {
    TableStore
} = WeaTableNew;

export class StaffSchemeStore {
    @observable tableStore = new TableStore();
    @observable topMenu = []
    @observable rightMenu = [];
    @observable condition = [];
    @observable searchCondition = [];
    @observable isEdit = true;
    @observable isNew = true;
    @observable isPanelShow = false; //高级搜索面板
    @observable form2 = new WeaForm();
    @observable form = new WeaForm();
    @observable form1 = new WeaForm();
    @observable planName = '';
    @observable conditionNum = 8;
    @observable ids = ''; //选择行id
    @observable searchConditionLoading = true;
    @observable nEdialogTitle = '';
    @observable visible = false;
    @observable dialogLoading = true;
    @observable schemeId = '';
    @observable date = '';
    @observable hasRight = '';




    @action
    getTableInfo(isOnChange = false) {
        let params;
        const {current} = this.tableStore;
        if (this.isEmptyObject(this.form2.getFormParams())) {
            params = {
                ...this.form2.getFormParams(),
                planName: this.planName
            };
        } else {
            params = {
                ...this.form2.getFormParams()
            };
        }
        Api.getSearchList(params).then(res => {
            if (res.code === 200) {
                this.setHasRight(res.data.hasRight);
                if(res.data.hasRight) {
                    isOnChange ? this.tableStore.getDatas(res.data.datas, current) : this.tableStore.getDatas(res.data.datas,1);
                }
            } else {
                message.warning(res.msg);
            }
        }, error => {
            message.warning(error.msg);
        })

    }

    //删除
    delete() {
        let params = {
            ids: this.ids
        };
        Api.deleteTableData(params).then(response => {
            return response.json()
        }).then(data => {
            if (data.code === 200) {
                message.success(i18n.message.deleteSuccess());
                this.getTableInfo();
            } else {
                message.warning(data.msg);
            }
        })
            .catch(error => {
                message.warning(error.msg);
            })
    }

    save() {
        let params = {
            ...this.form.getFormParams()
        };
        this.form.validateForm().then(f => {
            if (f.isValid) {
                Api.add(params).then(response => {
                    return response.json()
                }).then(data => {
                    if (data.code === 200) {
                        message.success(data.msg);
                        this.getTableInfo();
                        this.setVisible(false);
                    } else {
                        message.warning(data.msg);
                    }
                }).catch(error => {
                    message.warning(error.msg);
                })
            } else {
                f.showErrors();
                this.setDate(new Date());
            }
        });
    }

    edit() {
        let params = { ...this.form.getFormParams(), id: this.schemeId };
        this.form.validateForm().then(f => {
            if (f.isValid) {
                Api.edit(params).then(response => {
                    return response.json()
                }).then(data => {
                    if (data.code === 200) {
                        message.success(data.msg);
                        this.getTableInfo(true);
                        this.setVisible(false);
                    } else {
                        message.warning(data.msg);
                    }
                }).catch(error => {
                    message.warning(error.msg);
                })
            } else {
                f.showErrors();
                this.setDate(new Date());
            }
        });
    }

    updateForbiddenTag(checked, id) {
        let params = {
            forbiddenTag: checked,
            id: id
        }
        Api.updateForbiddenTag(params).then(response => {
            return response.json()
        }).then(data => {
            if (data.code === 200) {
                message.success(data.msg);
                this.getTableInfo(true);
            } else {
                message.warning(data.msg);
            }
        }).catch(error => {
            message.warning(error.msg);
        })

    }

    getForm() {
        let params = this.isNew ? {} : {
            id: this.schemeId
        }
        this.setDialogLoadingStatus(true);

        Api.getSchemeForm(params).then(res => {
            if (res.code === 200) {
                this.setDialogLoadingStatus(false);
                res.data.condition && this.setCondition(res.data.condition);
                res.data.condition && this.form.initFormFields(res.data.condition);
            } else {
                message.warning(res.msg);
            }
        }, error => {
            message.warning(error.msg);
        })

    }

    getSearchCondition() {
        this.setScLoadingStatus(false);
        Api.getAdvanceSearchCondition().then(res => {
            if (res.code === 200) {
                this.setScLoadingStatus(false);
                res.data.conditions && this.setSearchCondition(res.data.conditions);
                res.data.conditions && this.form2.initFormFields(res.data.conditions);
            } else {
                message.warning(res.msg);
            }
        }, error => {
            message.warning(error.msg);
        })
    }


    @action
    getHasRight() {
        Api.getHasRight().then(res => {
            if (res.code === 200) {
                res.data.rightMenu && this.setRightMenu(res.data.rightMenu);
                res.data.topMenu && this.setTopMenu(res.data.topMenu);
            } else {
                message.warning(res.msg);
            }
        }, error => {
            message.warning(error.msg);
        })
    }

    updateConditions(val) {
        const timeStartValue = val+'-01-01';
        const timeEndValue = val+'-12-31'
        // const label = "年度"
        // let item = findIndex(this.condition[0].items,{label});
        this.form.updateFields({
            timeStart: {
                value: timeStartValue
            }
        });
        this.form.updateFields({
            timeEnd: {
                value: timeEndValue
            }
        });



    }

    updateFields(val) {
        this.form2.updateFields({
            planName: {
                value: val
            }
        });
    }

    setSearchCondition(condition) {
        this.searchCondition = condition;
    }

    setScLoadingStatus(bool) {
        this.searchConditionLoading = bool;
    }

    setPanelStatus(bool) {
        this.isPanelShow = bool;
        bool && this.getSearchCondition();
        if (!bool) {
            this.scLoadingReset();
        }
    }

    setPlanName(val) {
        this.planName = val;
    }

    isEmptyObject(obj) {
        for (let key in obj) {
            return false;
        }
        return true;
    }

    setIds(ids) {
        this.ids = ids;
    }

    scLoadingReset() {
        this.searchConditionLoading = true;
    }


    formReset() {
        this.form = new WeaForm();
    }

    dialogLoadingReset() {
        this.dialogLoading = true;
    }

    setVisible(bool) {
        this.visible = bool;
        this.formReset();
        !bool && this.dialogLoadingReset();
    }

    setDialogLoadingStatus(bool) {
        this.dialogLoading = bool;
    }

    setNeDialogTitle(title) {
        this.nEdialogTitle = title;
    }

    setIsNew(bool) {
        this.isNew = bool;
    }

    setCondition(condition) {
        this.condition = condition;
    }

    setSchemeId(schemeId) {
        this.schemeId = schemeId;
    }

    @action
    setDate(date) {
        this.date = date;
    }

    setTopMenu(topMenu) {
        this.topMenu = topMenu;
    }

    setRightMenu(rightMenu) {
        this.rightMenu = rightMenu;
    }

    setHasRight(bool) {
        this.hasRight = bool;
    }

}